
#include<i86.h>
#include<string.h>
#include<stdlib.h>
#include<sys/types.h>
#include<sys/inline.h>
#include<sys/proxy.h>
#include<stdio.h>


typedef char mac_t[6];
typedef struct _rx_pkt rxpkt_t;

#define RX_LEN	1514	/* sizeof data field -- largest pkt	*/
						/* to receive (1514 is ethernet MTU	*/
						/* but may be set smaller to save	*/
						/* memory.							*/

struct _rx_pkt{
	rxpkt_t	*next;		/* linked list						*/
	short	lan;		/* interface identifier				*/
	mac_t	from_addr;	/* sent from this remote address	*/
	mac_t	to_addr;	/* destined for this address		*/
	int		len;		/* length of data received			*/
	char	data[RX_LEN];		 
	};


extern int rx_dropped;	/* number of dropped pkts on recv	*/
extern pid_t rx_done_proxy;

int rx_init( int n );
rxpkt_t * get_rxpkt();
void put_rxpkt( rxpkt_t *r );
void far * far rx_getbuf(int length, short m1, short m2, short m3);
int far rx_done(short lan, short m1, short m2, short m3);
